import map from 'lodash/map';
import set from 'lodash/set';
import get from 'lodash/get';
import isFunction from 'lodash/isFunction';
import error_handle from '@/common/error';

// const reset_config = function reset_config(settting:any):any ;

class Http {
	config = {
		baseUrl: '',
		header: {},
	}

	interceptor = {
		request(config:any):any {
			const req_config = config;
			set(req_config, 'header.X-Requested-With', 'XMLHttpRequest');
			set(req_config, 'header.mobileapp', 'true');
			const token = uni.getStorageSync('token') || "";
			set(req_config, 'header.Authorization', token);
			return req_config;
		},
		// response(res) {},
	}

	set_config(config:any):void {
		Object.keys(config).forEach((key:string):void => {
			(this as any).config[key] = config[key];
		});
	}

	post(settting:any):any {
		return this.ajax({
			...settting,
			method: 'POST'
		});
	}

	get(settting:any):any {
		return this.ajax({
			...settting,
			method: 'GET'
		});
	}
	
	put(settting:any):any {
		return this.ajax({
			...settting,
			method: 'PUT'
		});
	}
	
	delete(settting:any):any {
		return this.ajax({
			...settting,
			method: 'DELETE'
		});
	}

	async upPic(setting:any):Promise<any> {
		console.log(444444)
		let settingCopy = {
			type: 2,
			url: '/common/upload',
			...setting
		};
		if (!settingCopy.filePath) {
			return
		}
		const data = {
			prefix: "other"
		}
		return this.get({
			url: settingCopy.url,
			data,
			headers: {
				'content-type': 'application/x-www-form-urlencoded'
			},
		}).then((result:any) => {
			// console.log(111111111)
			return new Promise((resolve, reject) => {
				uni.uploadFile({
					url: result.host,
					filePath: settingCopy.filePath,
					name: 'file',
					formData: {
						name: settingCopy.filePath,
						key: result.dir,
						OSSAccessKeyId: result.accessid,
						policy: result.policy,
						signature: result.signature,
						expire: result.expire,
						callback: result.callback,
						dir: 'admin/'
					},
					success(res) {
						const _result = JSON.parse(res.data)
						// console.log(2222222)
						resolve(result.host + '/' + _result.url)
					},
					fail(res) {
						// console.log(333333333)
						reject(res)
					}
				})
			})
		})
	}

	ajax(settting:any):any {
		return new Promise((resolve, reject) => {
			const conf = this.reset_config(settting);
			uni.request({
				...conf,
				success: (res) => {
					const data = JSON.parse(res.data as string);
					if (data.status === 2000000) {
						resolve(data.res);
					} else {
						error_handle(data);
						reject(data);
					}
				},
				fail: (err) => {
					error_handle(err);
					reject(err);
				},
			});
		});
	}
	
	reset_config(settting:any):any {
		let {
			baseUrl,
			...other_configs
		} = this.config;
		const {
			url,
			...other_settings
		} = settting;
		if(settting.hasOwnProperty("baseUrl")){
			baseUrl = settting.baseUrl;
		}
		const new_url = baseUrl + url;
		let config = {
			url: new_url,
			...other_configs,
			...other_settings,
		};
		if (isFunction(this.interceptor.request)) {
			config = this.interceptor.request(config);
		}
		return config;
	}
}

export default Http;
