import {
	SET_TOKEN,
	LOGOUT,
	SET_ISLOGIN,
	SET_USERINFO,
	SET_REFERRERID,
	SET_ISNOTICE,
	SET_TABBARINDEX,
	SET_STARTTIME,
	SET_ENDTIME,
	SET_ISPLAY,
	SET_ADDRESS,
	SET_REMARK,
	SET_GOODS,
	SET_SEARCHHISTORY,
	SET_CARTGOODS,
	ADD_CARTGOODS,
	EMPTY_SEARCHHISTORY
} from '@/common/store/types';

const module = {
  namespaced: true,
  state() {
    return {
       token: uni.getStorageSync('token'),
	   isLogin: uni.getStorageSync('isLogin') || false,
	   userInfo: uni.getStorageSync('userInfo') || {},
	   referrerId: uni.getStorageSync('referrerId'),
	   isPlay: uni.getStorageSync('isPlay'),
	   goods: uni.getStorageSync('goods') || [],
	   searchHistory: uni.getStorageSync('searchHistory')||[],
	   cartGoods: uni.getStorageSync('cartGoods') || [],
	   address: null,
	   remark: '',
	   isNotice: false,
	   tabBarIndex: 0,
	   startTime: '',
	   endTime:''
    }
  },
  getters: {
    _token:(state:any)=> state.token,
	_isLogin: (state:any) => state.isLogin,
	_referrerId: (state:any) => state.referrerId,
	_userInfo:(state:any)=> JSON.parse(JSON.stringify(state.userInfo)),
	_isNotice: (state:any) => state.isNotice,
	_tabBarIndex: (state:any) => state.tabBarIndex,
	_startTime: (state:any) => state.startTime,
	_endTime: (state:any) => state.endTime,
	_isPlay: (state:any) => state.isPlay,
	_address: (state:any) => state.address,
	_remark: (state:any) => state.remark,
	_goods: (state:any) => state.goods,
	_searchHistory: (state: any) => JSON.parse(JSON.stringify(state.searchHistory)),
	_cartGoods:(state: any) => JSON.parse(JSON.stringify(state.cartGoods))
  },
  mutations: {
    // 登录成功将, token保存在localStorage中
    [SET_TOKEN]: (state:any, data:any) => {
      uni.setStorageSync('token', data);
      state.token = data;
    },
	// 退出登录将, token清空
	[LOGOUT]: (state:any) => {
	  uni.removeStorageSync('token');
	  uni.removeStorageSync('userInfo');
	  uni.removeStorageSync('isLogin');
	  state.token = '';
	  state.userInfo = null;
	  state.isLogin = false;
	},
	// 登录状态
	[SET_ISLOGIN]: (state:any, data:any) => {
	  uni.setStorageSync('isLogin', data);
	  state.isLogin = data;
	},
	// 用户信息
	[SET_USERINFO]: (state:any, data:any) => {
	  uni.setStorageSync('userInfo', data);
	  state.userInfo = data;
	},
	// 保存推荐人
	[SET_REFERRERID]: (state:any, data:any) => {
	  uni.setStorageSync('referrerId', data);
	  state.referrerId = data;
	},
	// tabbar
	[SET_TABBARINDEX]: (state:any, data:any) => {
		state.tabBarIndex = data;
	},
	[SET_STARTTIME]: (state:any, data:any) => {
	  state.startTime = data;
	},
	[SET_ENDTIME]: (state:any, data:any) => {
	  state.endTime = data;
	},
	[SET_ADDRESS]: (state:any, data:any) => {
	  state.address = data;
	},
	[SET_GOODS]: (state:any, data:any) => {
	  uni.setStorageSync('goods', data);
	  state.goods = data;
	},
	// 购物车数据
	[SET_CARTGOODS]: (state: any, data: any) => {
		uni.setStorageSync('cartGoods', data);
		state.cartGoods = data;
	},
	// 搜索历史数据
	[SET_SEARCHHISTORY]: (state: any, data: any) => {
		if(!data) return;
		let val:Array<any> = state.searchHistory||[]
		let index = val.findIndex((item: any) => item === data);
		(index > -1) && val.splice(index,1);
		val.unshift(data);
		uni.setStorageSync('searchHistory', val);
	},
	// 清空搜索记录
	[EMPTY_SEARCHHISTORY]:(state: any, data: any) => {
		state.searchHistory = [];
		uni.setStorageSync('searchHistory', []);
	}
  },
  actions: {
    [ADD_CARTGOODS]:({state,commit}:any,goodsInfo: any) => {
    	const cartFlag = state.cartGoods.find((res: any)=> res.sku_id == goodsInfo.sku_id)
    	
    	if(!cartFlag){
    		goodsInfo.check = false;
    		state.cartGoods.unshift(goodsInfo);
    	}else{
    		state.cartGoods.forEach((res: any)=>{
    			if(res.sku_id == goodsInfo.sku_id){
    				res.num += goodsInfo.num;
    			}
    		})
    		console.log('数量加的有点问题呀',state.cartGoods,goodsInfo.num);
    	}
    	commit(SET_CARTGOODS,state.cartGoods);
    	console.log('state.cartGoods------>',state.cartGoods)
    	console.log('goodsInfo------>',goodsInfo)
    }
  }
}

export default module;
