### 轮播图

轮播图，用于轮播图，组件名：``SwiperBanner``
基于 swiper、swiper-item封装的轮播组件

```html
 //右上角按钮插槽  暂时用不上  
<view class="collection" slot="collection" @click="collectionClick" >
	<i class="icon">&#xe686;</i>
</view>
```
### 使用方式

在 ``script`` 中引用组件 

```javascript
import SwiperBanner from "@/components/base/SwiperBanner.vue"

@Components({
	 components: {
		 SwiperBanner
	}
})

//或者
export default {
    components: {SwiperBanner}
}
```

在 ``template`` 中使用组件

```html
	<swiper-banner 
		:banner-detail="bannerDetail" 
		:banner-h="200" 
		:radius="5" 
		indicatorColor="#000">
	</swiper-banner>
```
### 属性说明

|属性名						|类型		|默认值					|说明		|
|---						|----		|---					|---		|
|bannerDetail				|array		|-						|轮播数据（数组或者数组对象）|
|imgKey						|string		|''						|单条数据对应的key值    |
|autoPlay					|boolean	|true					|自动切换		|
|indicatorDots				|boolean	|true					|是否自定义指示点   |
|dotsType					|string		|dot					|指示点样式（dot/digit） 		  |
|noIndicatorColor			|string		|rgba(255,255,255,0.6)	|未选中指示点颜色 当dotsType值为dot生效	|
|indicatorColor				|string		|#fff					|自定义指示点颜色 当dotsType值为dot生效	|
|bannerH					|number		|200					|轮播图高度		|
|radius						|number		|0						|自定义圆角	|
|preview					|boolean	|false					|开启预览图片 与点击跳转只可存在一个	|
|bannerType					|string		|''						|轮播样式类型 '3D'、''|
|previousNext				|string		|0rpx					| 轮播前后缩进尺寸（当bannerType为3D时使用）|



