const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
const TransformPages = require('uni-read-pages')
const {webpack} = new TransformPages()
const envDev = require('./.env.dev');
const envPrd = require('./env.prd');
const env = process.env.NODE_ENV === 'development' ? envDev : envPrd;
Object.keys(env).forEach(key => {
	process.env[key] = env[key];
});
const VUE_APP_REMOTE_HOST = process.env.VUE_APP_REMOTE_HOST;
module.exports = {
	transpileDependencies: ['uni-simple-router'],
	devServer: {
		disableHostCheck: true,
		proxy: {
			'/*': {
				target: `http://${VUE_APP_REMOTE_HOST}`,
				changeOrigin: true,
			},
		},
	},
	configureWebpack: {
			plugins: [
				new webpack.DefinePlugin({
					ROUTES: webpack.DefinePlugin.runtimeValue(() => {
						const tfPages = new TransformPages({
							includes: ['path', 'name', 'aliasPath', 'meta']
						});
						return JSON.stringify(tfPages.routes)
					}, true )
				})
				// new BundleAnalyzerPlugin(),
			],
		}
};
